public class Baum {

  // Die Wurzel des Baumes 
  private Knoten wurzel;
 
  //Erzeugt einen leeren Baum.
  public Baum() {
  }
  
  /*
   * Erzeugt einen Baum mit der Wurzel, die die Zahl wert enthaelt.
   * Die Wurzel hat keine Nachfolgerknoten.
   */

  public Baum(int wert) {
    wurzel = new Knoten(wert);
  }

    public Baum (int wert, Baum links, Baum rechts) {
        wurzel = new Knoten(wert);
	wurzel.setLinks(links.getWurzel());
	wurzel.setRechts(rechts.getWurzel());        
    }


    private Knoten getWurzel () {
	return this.wurzel;
    }

  
  
   // Liefert einen Strin, der den Baum in inorder-Notation 
   // darstellt.
   
   public String in_order() {
     return in_order(wurzel);
   }


  private static String in_order(Knoten knoten) {
    if (knoten != null) 
	return "(" + in_order(knoten.getLinks()) + ")" + knoten.getWert() + " " + "(" + in_order(knoten.getRechts()) + ")";
    else return "";
   
  }
  

  
   // Ueberprueft, ob der Baum leer ist.
   
  public boolean istLeer() {
    return wurzel == null;
  }


}
